zenilib: zenilib/jni/external/sdl/SDL/SDL_gamecontroller.h File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Classes | Typedefs | Enumerations | Functions
SDL_gamecontroller.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "SDL_joystick.h"`
`#include "begin_code.h"`
`#include "close_code.h"`

Go to the source code of this file.

## Classes

struct | SDL_GameControllerButtonBind

## Typedefs

typedef struct _SDL_GameController | SDL_GameController
typedef struct SDL_GameControllerButtonBind | SDL_GameControllerButtonBind

## Enumerations

enum

SDL_GameControllerAxis {
SDL_CONTROLLER_AXIS_INVALID = -1, SDL_CONTROLLER_AXIS_LEFTX, SDL_CONTROLLER_AXIS_LEFTY, SDL_CONTROLLER_AXIS_RIGHTX,
SDL_CONTROLLER_AXIS_RIGHTY, SDL_CONTROLLER_AXIS_TRIGGERLEFT, SDL_CONTROLLER_AXIS_TRIGGERRIGHT, SDL_CONTROLLER_AXIS_MAX
}

enum | SDL_GameControllerBindType { SDL_CONTROLLER_BINDTYPE_NONE = 0, SDL_CONTROLLER_BINDTYPE_BUTTON, SDL_CONTROLLER_BINDTYPE_AXIS, SDL_CONTROLLER_BINDTYPE_HAT }

enum

SDL_GameControllerButton {
SDL_CONTROLLER_BUTTON_INVALID = -1, SDL_CONTROLLER_BUTTON_A, SDL_CONTROLLER_BUTTON_B, SDL_CONTROLLER_BUTTON_X,
SDL_CONTROLLER_BUTTON_Y, SDL_CONTROLLER_BUTTON_BACK, SDL_CONTROLLER_BUTTON_GUIDE, SDL_CONTROLLER_BUTTON_START,
SDL_CONTROLLER_BUTTON_LEFTSTICK, SDL_CONTROLLER_BUTTON_RIGHTSTICK, SDL_CONTROLLER_BUTTON_LEFTSHOULDER, SDL_CONTROLLER_BUTTON_RIGHTSHOULDER,
SDL_CONTROLLER_BUTTON_DPAD_UP, SDL_CONTROLLER_BUTTON_DPAD_DOWN, SDL_CONTROLLER_BUTTON_DPAD_LEFT, SDL_CONTROLLER_BUTTON_DPAD_RIGHT,
SDL_CONTROLLER_BUTTON_MAX
}

## Functions

DECLSPEC int SDLCALL | SDL_GameControllerAddMapping (const char *mappingString)
DECLSPEC void SDLCALL | SDL_GameControllerClose (SDL_GameController *gamecontroller)
DECLSPEC int SDLCALL | SDL_GameControllerEventState (int state)
DECLSPEC SDL_bool SDLCALL | SDL_GameControllerGetAttached (SDL_GameController *gamecontroller)
DECLSPEC Sint16 SDLCALL | SDL_GameControllerGetAxis (SDL_GameController *gamecontroller, SDL_GameControllerAxis axis)
DECLSPEC SDL_GameControllerAxis SDLCALL | SDL_GameControllerGetAxisFromString (const char *pchString)
DECLSPEC SDL_GameControllerButtonBind SDLCALL | SDL_GameControllerGetBindForAxis (SDL_GameController *gamecontroller, SDL_GameControllerAxis axis)
DECLSPEC SDL_GameControllerButtonBind SDLCALL | SDL_GameControllerGetBindForButton (SDL_GameController *gamecontroller, SDL_GameControllerButton button)
DECLSPEC Uint8 SDLCALL | SDL_GameControllerGetButton (SDL_GameController *gamecontroller, SDL_GameControllerButton button)
DECLSPEC SDL_GameControllerButton SDLCALL | SDL_GameControllerGetButtonFromString (const char *pchString)
DECLSPEC SDL_Joystick *SDLCALL | SDL_GameControllerGetJoystick (SDL_GameController *gamecontroller)
DECLSPEC const char *SDLCALL | SDL_GameControllerGetStringForAxis (SDL_GameControllerAxis axis)
DECLSPEC const char *SDLCALL | SDL_GameControllerGetStringForButton (SDL_GameControllerButton button)
DECLSPEC char *SDLCALL | SDL_GameControllerMapping (SDL_GameController *gamecontroller)
DECLSPEC char *SDLCALL | SDL_GameControllerMappingForGUID (SDL_JoystickGUID guid)
DECLSPEC const char *SDLCALL | SDL_GameControllerName (SDL_GameController *gamecontroller)
DECLSPEC const char *SDLCALL | SDL_GameControllerNameForIndex (int joystick_index)
DECLSPEC SDL_GameController *SDLCALL | SDL_GameControllerOpen (int joystick_index)
DECLSPEC void SDLCALL | SDL_GameControllerUpdate (void)
DECLSPEC SDL_bool SDLCALL | SDL_IsGameController (int joystick_index)

## Detailed Description

Include file for SDL game controller event handling

In order to use these functions, SDL_Init() must have been called with the SDL_INIT_JOYSTICK flag. This causes SDL to scan the system for game controllers, and load appropriate drivers.

If you would like to receive controller updates while the application is in the background, you should set the following hint before calling SDL_Init(): SDL_HINT_JOYSTICK_ALLOW_BACKGROUND_EVENTS

Definition in file SDL_gamecontroller.h.

## Typedef Documentation

typedef struct _SDL_GameController SDL_GameController

Definition at line 55 of file SDL_gamecontroller.h.

typedef struct SDL_GameControllerButtonBind SDL_GameControllerButtonBind

Get the SDL joystick layer binding for this controller button/axis mapping

## Enumeration Type Documentation

enum SDL_GameControllerAxis

The list of axes available from a controller

Enumerator
SDL_CONTROLLER_AXIS_INVALID |
SDL_CONTROLLER_AXIS_LEFTX |
SDL_CONTROLLER_AXIS_LEFTY |
SDL_CONTROLLER_AXIS_RIGHTX |
SDL_CONTROLLER_AXIS_RIGHTY |
SDL_CONTROLLER_AXIS_TRIGGERLEFT |
SDL_CONTROLLER_AXIS_TRIGGERRIGHT |
SDL_CONTROLLER_AXIS_MAX |

Definition at line 194 of file SDL_gamecontroller.h.

enum SDL_GameControllerBindType

Enumerator
SDL_CONTROLLER_BINDTYPE_NONE |
SDL_CONTROLLER_BINDTYPE_BUTTON |
SDL_CONTROLLER_BINDTYPE_AXIS |
SDL_CONTROLLER_BINDTYPE_HAT |

Definition at line 58 of file SDL_gamecontroller.h.

enum SDL_GameControllerButton

The list of buttons available from a controller

Enumerator
SDL_CONTROLLER_BUTTON_INVALID |
SDL_CONTROLLER_BUTTON_A |
SDL_CONTROLLER_BUTTON_B |
SDL_CONTROLLER_BUTTON_X |
SDL_CONTROLLER_BUTTON_Y |
SDL_CONTROLLER_BUTTON_BACK |
SDL_CONTROLLER_BUTTON_GUIDE |
SDL_CONTROLLER_BUTTON_START |
SDL_CONTROLLER_BUTTON_LEFTSTICK |
SDL_CONTROLLER_BUTTON_RIGHTSTICK |
SDL_CONTROLLER_BUTTON_LEFTSHOULDER |
SDL_CONTROLLER_BUTTON_RIGHTSHOULDER |
SDL_CONTROLLER_BUTTON_DPAD_UP |
SDL_CONTROLLER_BUTTON_DPAD_DOWN |
SDL_CONTROLLER_BUTTON_DPAD_LEFT |
SDL_CONTROLLER_BUTTON_DPAD_RIGHT |
SDL_CONTROLLER_BUTTON_MAX |

Definition at line 237 of file SDL_gamecontroller.h.

## Function Documentation

DECLSPEC int SDLCALL SDL_GameControllerAddMapping | ( | const char * | mappingString | ) |

To count the number of game controllers in the system for the following: int nJoysticks = SDL_NumJoysticks(); int nGameControllers = 0; for ( int i = 0; i < nJoysticks; i++ ) { if ( SDL_IsGameController(i) ) { nGameControllers++; } }

Using the SDL_HINT_GAMECONTROLLERCONFIG hint or the SDL_GameControllerAddMapping you can add support for controllers SDL is unaware of or cause an existing controller to have a different binding. The format is: guid,name,mappings

Where GUID is the string value from SDL_JoystickGetGUIDString(), name is the human readable string for the device and mappings are controller mappings to joystick ones. Under Windows there is a reserved GUID of "xinput" that covers any XInput devices. The mapping format for joystick is: bX - a joystick button, index X hX.Y - hat X with value Y aX - axis X of the joystick Buttons can be used as a controller axis and vice versa.

This string shows an example of a valid mapping for a controller "341a3608000000000000504944564944,Afterglow PS3 Controller,a:b1,b:b2,y:b3,x:b0,start:b9,guide:b12,back:b8,dpup:h0.1,dpleft:h0.8,dpdown:h0.4,dpright:h0.2,leftshoulder:b4,rightshoulder:b5,leftstick:b10,rightstick:b11,leftx:a0,lefty:a1,rightx:a2,righty:a3,lefttrigger:b6,righttrigger:b7", Add or update an existing mapping configuration

Returns
  1 if mapping is added, 0 if updated, -1 on error

Definition at line 662 of file SDL_gamecontroller.c.

References s_pSupportedControllers, SDL_FALSE, SDL_free(), SDL_JoystickGetGUIDFromString(), SDL_malloc(), SDL_OutOfMemory, SDL_PrivateGameControllerRefreshMapping(), SDL_PrivateGetControllerGUIDFromMappingString(), SDL_PrivateGetControllerMappingForGUID(), SDL_PrivateGetControllerMappingFromMappingString(), SDL_PrivateGetControllerNameFromMappingString(), SDL_strcasecmp(), and SDL_TRUE.

Referenced by SDL_GameControllerInit(), and SDL_GameControllerLoadHints().

DECLSPEC void SDLCALL SDL_GameControllerClose | ( | SDL_GameController * | gamecontroller | ) |

Close a controller previously opened with SDL_GameControllerOpen().

Definition at line 1086 of file SDL_gamecontroller.c.

References NULL, SDL_free(), SDL_gamecontrollers, and SDL_JoystickClose().

Referenced by SDL_GameControllerQuit().

DECLSPEC int SDLCALL SDL_GameControllerEventState | ( | int | state | ) |

Enable/disable controller event polling.

If controller events are disabled, you must call SDL_GameControllerUpdate() yourself and check the state of the controller when you want controller information.

The state can be one of SDL_QUERY, SDL_ENABLE or SDL_IGNORE.

Definition at line 1218 of file SDL_gamecontroller.c.

References i, SDL_arraysize, SDL_CONTROLLERAXISMOTION, SDL_CONTROLLERBUTTONDOWN, SDL_CONTROLLERBUTTONUP, SDL_CONTROLLERDEVICEADDED, SDL_CONTROLLERDEVICEREMAPPED, SDL_CONTROLLERDEVICEREMOVED, SDL_ENABLE, SDL_EventState(), SDL_IGNORE, and SDL_QUERY.

Referenced by Zeni::Controllers::enable().

DECLSPEC SDL_bool SDLCALL SDL_GameControllerGetAttached | ( | SDL_GameController * | gamecontroller | ) |

Returns SDL_TRUE if the controller has been opened and currently connected, or SDL_FALSE if it has not.

Definition at line 991 of file SDL_gamecontroller.c.

References SDL_FALSE, and SDL_JoystickGetAttached().

Referenced by Zeni::Controllers::is_controller_connected().

DECLSPEC Sint16 SDLCALL SDL_GameControllerGetAxis | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerAxis | axis
| ) |  |

Get the current state of an axis control on a game controller.

The state is a value ranging from -32768 to 32767.

The axis indices start at index 0.

Definition at line 921 of file SDL_gamecontroller.c.

References SDL_CONTROLLER_AXIS_TRIGGERLEFT, SDL_CONTROLLER_AXIS_TRIGGERRIGHT, SDL_JoystickGetAxis(), and SDL_JoystickGetButton().

DECLSPEC SDL_GameControllerAxis SDLCALL SDL_GameControllerGetAxisFromString | ( | const char * | pchString | ) |

turn this string into a axis mapping

Definition at line 309 of file SDL_gamecontroller.c.

References map_StringForControllerAxis, SDL_CONTROLLER_AXIS_INVALID, and SDL_strcasecmp().

Referenced by SDL_PrivateGameControllerParseButton().

DECLSPEC SDL_GameControllerButtonBind SDLCALL SDL_GameControllerGetBindForAxis | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerAxis | axis
| ) |  |

Get the SDL joystick layer binding for this controller button mapping

Get the SDL joystick layer binding for this controller axis mapping

Definition at line 1027 of file SDL_gamecontroller.c.

References SDL_GameControllerButtonBind::bindType, SDL_GameControllerButtonBind::button, SDL_CONTROLLER_AXIS_INVALID, SDL_CONTROLLER_BINDTYPE_AXIS, SDL_CONTROLLER_BINDTYPE_BUTTON, SDL_memset(), and SDL_GameControllerButtonBind::value.

DECLSPEC SDL_GameControllerButtonBind SDLCALL SDL_GameControllerGetBindForButton | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerButton | button
| ) |  |

Get the SDL joystick layer binding for this controller button mapping

Definition at line 1053 of file SDL_gamecontroller.c.

References SDL_GameControllerButtonBind::axis, SDL_GameControllerButtonBind::bindType, SDL_GameControllerButtonBind::button, SDL_GameControllerButtonBind::hat, SDL_CONTROLLER_BINDTYPE_AXIS, SDL_CONTROLLER_BINDTYPE_BUTTON, SDL_CONTROLLER_BINDTYPE_HAT, SDL_CONTROLLER_BUTTON_INVALID, SDL_memset(), and SDL_GameControllerButtonBind::value.

DECLSPEC Uint8 SDLCALL SDL_GameControllerGetButton | ( | SDL_GameController * | gamecontroller,
|  | SDL_GameControllerButton | button
| ) |  |

Get the current state of a button on a game controller.

The button indices start at index 0.

Definition at line 956 of file SDL_gamecontroller.c.

References ABS, SDL_JoystickGetAxis(), SDL_JoystickGetButton(), and SDL_JoystickGetHat().

DECLSPEC SDL_GameControllerButton SDLCALL SDL_GameControllerGetButtonFromString | ( | const char * | pchString | ) |

turn this string into a button mapping

Definition at line 357 of file SDL_gamecontroller.c.

References map_StringForControllerButton, SDL_CONTROLLER_BUTTON_INVALID, and SDL_strcasecmp().

Referenced by SDL_PrivateGameControllerParseButton().

DECLSPEC SDL_Joystick* SDLCALL SDL_GameControllerGetJoystick | ( | SDL_GameController * | gamecontroller | ) |

Get the underlying joystick object used by a controller

Definition at line 1016 of file SDL_gamecontroller.c.

References NULL.

DECLSPEC const char* SDLCALL SDL_GameControllerGetStringForAxis | ( | SDL_GameControllerAxis | axis | ) |

turn this axis enum into a string mapping

Definition at line 326 of file SDL_gamecontroller.c.

References map_StringForControllerAxis, NULL, SDL_CONTROLLER_AXIS_INVALID, and SDL_CONTROLLER_AXIS_MAX.

DECLSPEC const char* SDLCALL SDL_GameControllerGetStringForButton | ( | SDL_GameControllerButton | button | ) |

turn this button enum into a string mapping

Definition at line 374 of file SDL_gamecontroller.c.

References map_StringForControllerButton, NULL, SDL_CONTROLLER_BUTTON_INVALID, and SDL_CONTROLLER_BUTTON_MAX.

DECLSPEC char* SDLCALL SDL_GameControllerMapping | ( | SDL_GameController * | gamecontroller | ) |

Get a mapping string for an open GameController

Returns
  the mapping string. Must be freed with SDL_free. Returns NULL if no mapping is available

Definition at line 751 of file SDL_gamecontroller.c.

References SDL_GameControllerMappingForGUID().

Referenced by Zeni::Controllers::device_added().

DECLSPEC char* SDLCALL SDL_GameControllerMappingForGUID | ( | SDL_JoystickGUID | guid | ) |

Get a mapping string for a GUID

Returns
  the mapping string. Must be freed with SDL_free. Returns NULL if no mapping is available

Definition at line 731 of file SDL_gamecontroller.c.

References NULL, SDL_JoystickGetGUIDString(), SDL_malloc(), SDL_PrivateGetControllerMappingForGUID(), SDL_snprintf(), and SDL_strlen().

Referenced by SDL_GameControllerMapping().

DECLSPEC const char* SDLCALL SDL_GameControllerName | ( | SDL_GameController * | gamecontroller | ) |

Return the name for this currently opened controller

Definition at line 1004 of file SDL_gamecontroller.c.

References NULL.

DECLSPEC const char* SDLCALL SDL_GameControllerNameForIndex | ( | int | joystick_index | ) |

Get the implementation dependent name of a game controller. This can be called before any controllers are opened. If no name can be found, this function returns NULL.

Definition at line 815 of file SDL_gamecontroller.c.

References NULL, and SDL_PrivateGetControllerMapping().

DECLSPEC SDL_GameController* SDLCALL SDL_GameControllerOpen | ( | int | joystick_index | ) |

Open a game controller for use. The index passed as an argument refers to the N'th game controller on the system. This index is the value which will identify this controller in future controller events.

Returns
  A controller identifier, or NULL if an error occurred.

Definition at line 849 of file SDL_gamecontroller.c.

References NULL, SDL_free(), SDL_gamecontrollers, SDL_JoystickOpen(), SDL_malloc(), SDL_memset(), SDL_NumJoysticks(), SDL_OutOfMemory, SDL_PrivateGetControllerMapping(), SDL_PrivateLoadButtonMapping(), SDL_SetError(), SDL_SYS_GetInstanceIdOfDeviceIndex(), and SDL_SYS_JoystickUpdate().

Referenced by Zeni::Controllers::device_added().

DECLSPEC void SDLCALL SDL_GameControllerUpdate | ( | void |  | ) |

Update the current state of the open game controllers.

This is called automatically by the event loop if any game controller events are enabled.

Definition at line 910 of file SDL_gamecontroller.c.

References SDL_JoystickUpdate().

DECLSPEC SDL_bool SDLCALL SDL_IsGameController | ( | int | joystick_index | ) |

Is the joystick on this index supported by the game controller interface?

Definition at line 830 of file SDL_gamecontroller.c.

References SDL_FALSE, SDL_PrivateGetControllerMapping(), and SDL_TRUE.

Referenced by Zeni::Controllers::device_added(), and SDL_GameControllerEventWatcher().